<%@ page import="java.net.*,java.io.*,
                 javax.xml.transform.TransformerFactoryConfigurationError" %>

<%--
PRISMIQ MediaPlayer Remote Control JSP Example, Portions copyright 2003 "GassyBadger" and PRISMIQ, Inc.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


A sample JSP page that illustrates remotely controlling the Media Agent on the PRISMIQ MediaPlayer.
This JSP is designed to run in the Tomcat Server that is part of PRISMIQ's MediaManager software.

Simple Instructions to use this file are available in readme.html, but the basics:

Querying http://localhost:8080/mserver/remotecontrol.jsp will output a list of all the audio files contained in
media.xml. Clicking on a link will reload the page, with the argument song=<id>, where the ID the the
media used in media.xml and media.map. The page will reload and send the play command to the MediaPlayer.
Make sure to set the MediaPlayer's IP address below!

The HTML that is output is generated by the Stylesheet in remotemedia.xsl - change it to change the
HTML output

Taken from the cool work done by "GassyBadger" on the PRISMIQ.org (http://www.PRISMIQ.org) community forum
(http://www.prismiq.org/modules.php?op=modload&name=phpBB2&file=viewtopic&t=115&start=0&postdays=0&
postorder=asc&highlight=&sid=6d995d7103b575b62f816209dd127cae)


Version 1.0, 6/13/2003, GassyBadger on the PRISMIQ.org forums, initial version.
Version 1.1, 6/19/2003, kkopp, added outputPlaylist() and check for "song" parameter.
--%>
<%
    // Set this to the IP address of your MediaPlayer
    String mplayerIP = "10.0.0.101";

    String song = request.getParameter("song");
    if (song != null) {
        play(mplayerIP, song);
    }
    outputPlaylist(request, response);
%>


<%!

    private void outputPlaylist(HttpServletRequest request, HttpServletResponse response)
            throws TransformerFactoryConfigurationError,IOException, javax.xml.transform.TransformerException {
        // 1. Instantiate a TransformerFactory.
        javax.xml.transform.TransformerFactory tFactory =
                javax.xml.transform.TransformerFactory.newInstance();

        // 2. Use the TransformerFactory to process the stylesheet Source and
        //    generate a Transformer.
        URL styleSheet = new URL(new URL(request.getRequestURL().toString()), "/mserver/files/remotemedia.xsl");
        javax.xml.transform.Transformer transformer = tFactory.newTransformer
                (new javax.xml.transform.stream.StreamSource(styleSheet.toExternalForm()));

        // 3. Use the Transformer to transform an XML Source and send the
        //    output to a Result object.
        // The Super-secret URL to get media.xml:
        //	  http://127.0.0.1:8080/mserver/system/getContentData?type=media
        URL media = new URL(new URL(request.getRequestURL().toString()), "/mserver/system/getContentData?type=media");
        transformer.transform
                (new javax.xml.transform.stream.StreamSource(media.toExternalForm()),
                 new javax.xml.transform.stream.StreamResult(response.getOutputStream()));
    }

    private void play(String ip, String song )
            throws UnknownHostException, IOException {
        send(ip,"SET SERVER_ADDR " + InetAddress.getLocalHost().getHostAddress() );
        send(ip,"DEV_OPEN AUDIO_ONLY");
        send(ip,"SET MEDIA_TITLE \"" + song + "\"");
        send(ip,"LOAD");
        send(ip,"PLAY");
        send(ip,"QUIT");
    }

    private String send (String ip, String command )
            throws UnknownHostException, IOException {

        int port = 2253;

        Socket socket = null;
        String result = null;

        try {
            socket = new Socket(ip, port);
            PrintWriter out = new PrintWriter( socket.getOutputStream(), true );
            BufferedReader in = new BufferedReader(
                    new InputStreamReader( socket.getInputStream() ) );
            out.println( command );
            result = in.readLine();
            if ( !result.startsWith( "200" ) ) {
                throw new IOException("MAgent Error Code: "+ result);
            }
        } finally {
            socket.close();
        }
        return result;
    }
%>